/************************************************************************/
/*																		*/
/*	SFSPI.h	--	Declaration for SFSPI library 	    				    */
/*																		*/
/************************************************************************/
/*	Author:		Michelle Yu												*/
/*	Copyright 2011, Digilent Inc.										*/
/************************************************************************/
/*  File Description:													*/
/*		This file declares functions for SFSPI							*/
/*																		*/
/************************************************************************/
/*  Revision History:													*/
/*																		*/
/*	09/09/2011(MichelleY): created										*/
/*																		*/
/************************************************************************/
#if !defined(SFSPI_H)
#define SFSPI_H


/* ------------------------------------------------------------ */
/*				Include File Definitions						*/
/* ------------------------------------------------------------ */
#include <inttypes.h>
#include <DSPI.h>


/* ------------------------------------------------------------ */
/*					Procedure Declarations						*/
/* ------------------------------------------------------------ */


class SFSPI {
public:

  //setup SPI
  void begin();
  
  //Procedure functions
  int getDeviceID();
  uint8_t normalRead(int address);
  uint8_t fastRead(int address);
  void writePage(uint8_t writeData, int address);
  void sectorErase(int address);
  void bulkErase();
  void writeSR(uint8_t setReg);
  
private:
  //utility function
  void  writeEnable();
  uint8_t readSR();
  void  waitForWrite();
  DSPI0 mySPI;
};



#endif